#' .. content for \description{} (no empty lines) ..
#'
#' .. content for \details{} ..
#'
#' @title
#' @param Inputs
calc_gearing <- function(Inputs) {

  #This function is for generating alternative average gearin.
  #Boomberg API fails to retrieve Field F1468 using BDH uusing BDp hack isntead
  
  StartDate <- Inputs[[1]] - 30
  EndDate <- Inputs[[2]]
  Firms <- Inputs[[3]]
  Period <- Inputs[[4]]
  
  blpConnect() 
  
  Fields1 <- c("F1468")
  Fields2 <- c("NET_DEBT", "CUR_MKT_CAP", "EFF_TAX_RATE", "F1531")
  
  #Get the IFRS16 indicator
  
  F1468 <- read_xlsx("inputs/F1468Input.xlsx", sheet = 2, skip = 2)
  colnames(F1468)[1] <- "Date"
  F1468 <- tail(F1468, -2)
  F1468$Date <- as.numeric(F1468$Date)
  
  F1468$Date <- as.Date(F1468$Date, origin = "1899-12-30")

  F1468 <- pivot_longer(F1468, !Date)
  
  colnames(F1468)[2] <- "Code"
  
  #Get the date IFRS16 started
  
  F1468 <- F1468 %>% group_by(Code) %>% filter(value == 1) %>% summarise(MinDate = min(Date, na.rm = TRUE))
  
  
  FirmDataList2 <- bdh(securities = Firms$Code, fields = Fields2, start.date =  StartDate,
                       end.date = EndDate, options = c("CDR" = "7D"), overrides = c("EQY_FUND_CRNCY" = "USD")) #the CDR is 7D option means all days are extracted
  

  FirmData2 <- bind_rows(FirmDataList2, .id = "Code")
  
  #If IFRS 16 has been implemented remove F1531 (leases)
  #Merge the date it was implemented
  
  FirmData2 <- left_join(FirmData2, F1468, by ="Code")
  
  FirmData2 <- mutate(FirmData2, adjNet_Debt = ifelse(date >= MinDate, NET_DEBT - F1531, NET_DEBT))
  
  FirmData2 <- mutate(FirmData2, adjNet_Debt = ifelse(is.na(MinDate), NET_DEBT, adjNet_Debt))
  
  FirmData2 <- select(FirmData2, Code, date, F1531, MinDate, adjNet_Debt)
  
  #Write out the data
  
  FirmData2
}


