#' .. content for \description{} (no empty lines) ..
#'
#' .. content for \details{} ..
#'
#' @title
#' @param Data
#' @param Inputs
clean_data_daily <- function(Data, Inputs) {

  CombinedData <- Data
  StartDate <- Inputs[[1]]
  
  CombinedData$Weekday <- strftime(CombinedData$date, "%u") %>% as.numeric()  #7 is Sunday, 6/7 can't be trading days
  
  #Remove weekend days
  
  CombinedData <- filter(CombinedData, Weekday != 6 & Weekday != 7)
  
  #Remove NA days
  
  CombinedData <- filter(CombinedData, !is.na(PX_LAST))
  
  ####Step 4 - Get data ready for beta estimation####
  
  #Calculate daily changes in prices
  
  CombinedData <- CombinedData %>% group_by(Code) %>%
    mutate(PX_LAST_Daily = lag(PX_LAST, 1)) %>% as.data.frame()
  
  CombinedData <- CombinedData %>% group_by(Code) %>%
    mutate(INDEX_PX_LAST_Daily = lag(INDEX_PX_LAST, 1)) %>% as.data.frame()
  
  #Calculate change in price for index
  
  CombinedData <- CombinedData %>%
    mutate(PX_LAST_Daily_change = (PX_LAST - PX_LAST_Daily)/PX_LAST_Daily)
  
  CombinedData <- CombinedData %>%
    mutate(INDEX_PX_LAST_Daily_change = (INDEX_PX_LAST - INDEX_PX_LAST_Daily)/INDEX_PX_LAST_Daily)
  
  #Calculate gearing
  
  CombinedData <- CombinedData %>%
    mutate(GearingDE = NET_DEBT/CUR_MKT_CAP, GearingDV = NET_DEBT/(CUR_MKT_CAP + NET_DEBT))
  
  #Set the time period using Inputs
  
  CombinedData <- filter(CombinedData, date >= StartDate)
  
  #Writeout the raw data
  
  CombinedData

}
