#' .. content for \description{} (no empty lines) ..
#'
#' .. content for \details{} ..
#'
#' @title
#' @param Data
#' @param Inputs
clean_data_fourweekly <- function(Data, Inputs) {

  CombinedData <- Data
  StartDate <- Inputs[[1]]
  EndDate <- Inputs[[2]]
  
  CombinedData$Weekday <- strftime(CombinedData$date, "%u") %>% as.numeric()  #7 is Sunday, 6/7 can't be trading days
  
  dates <- seq.Date(StartDate, EndDate , by = 1)
  
  dates <- as.data.frame(dates)
  
  dates$Weekday <- strftime(dates$dates, "%u") %>% as.numeric()
  
  #Pick the first weekday 
  #Weekends are 6 and 7
  
  WeekdayIndicator <- dates$Weekday
  
  Ind <- 0
  
  for(i in 1:length(WeekdayIndicator)){
    if(WeekdayIndicator[i]== 6 | WeekdayIndicator[i]== 7){
      Ind <- Ind + 1
    } else {
      break
    }}
  
  DateVector <- dates$dates
  
  DateVector <- DateVector[Ind:length(DateVector)]
  
  MonthVector <- c(1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28)
  
  MonthVector <- rep(MonthVector, length.out = length(DateVector))
  
  MonthIndicator <- data.frame(date = DateVector, MonthIndicator = MonthVector)
  
  CombinedData <- left_join(CombinedData, MonthIndicator, by = "date")
  
  #write.csv(CombinedDataFinal, "CombinedDataFinal.csv")
  
  ####Step 4 - Get data ready for beta estimation####
  
  #Calculate weekly changes in prices
  
  CombinedData <- CombinedData %>% group_by(Code, MonthIndicator) %>%
    mutate(PX_LAST_Weekly = lag(PX_LAST, 1)) %>% as.data.frame()
  
  CombinedData <- CombinedData %>% group_by(Code, MonthIndicator) %>%
    mutate(INDEX_PX_LAST_Weekly = lag(INDEX_PX_LAST, 1)) %>% as.data.frame()
  
  #write.csv(CombinedData, "CombinedData.csv")
  
  #Calculate change in price for index
  
  CombinedData <- CombinedData %>%
    mutate(PX_LAST_weekly_change = (PX_LAST - PX_LAST_Weekly)/PX_LAST_Weekly)
  
  CombinedData <- CombinedData %>%
    mutate(INDEX_PX_LAST_weekly_change = (INDEX_PX_LAST - INDEX_PX_LAST_Weekly)/INDEX_PX_LAST_Weekly)
  
  #Calculate gearing
  
  CombinedData <- CombinedData %>%
    mutate(GearingDE = NET_DEBT/CUR_MKT_CAP, GearingDV = NET_DEBT/(CUR_MKT_CAP + NET_DEBT))
  
  #Set the time period using Inputs
  
  CombinedData <- filter(CombinedData, date >= StartDate)
  
  #Remove weekend days
  
  CombinedData <- filter(CombinedData, Weekday != 6 & Weekday != 7)
  
  #Writeout the raw data
  
  CombinedData
  
}
