#' .. content for \description{} (no empty lines) ..
#'
#' .. content for \details{} ..
#'
#' @title
#' @param CleanedDataDaily
#' @param AltGearing
estimate_beta_daily <- function(CleanedDataDaily, AltGearing) {

  CombinedData <- CleanedDataDaily
  AltGearing <- AltGearing
  
  ####Step 5 - Calculate betas####
  #Need to calculate a regression for:
  #Every reference day
  #Every firm
  
  ####Error handling####
  
  #Remove any firm where all results in index (i.e. index not identified) are NA
  
  `%notin%` <- Negate(`%in%`)
  
  IndexNA <- CombinedData %>% group_by(Code) %>% summarise(test = all(is.na(INDEX_PX_LAST_Daily_change)))
  IndexNA <- filter(IndexNA, test == TRUE)
  IndexNA <- unique(IndexNA$Code)
  
  CombinedData <- filter(CombinedData, Code  %notin% IndexNA)
  
  CombinedData <- filter(CombinedData, !is.na(PX_LAST_Daily_change))
  CombinedData <- filter(CombinedData, is.finite(PX_LAST_Daily_change))
  
  #Using a groupwise operation
  
  RegressionResults <- CombinedData %>% group_by(Code) %>% do(model = lm(PX_LAST_Daily_change ~ INDEX_PX_LAST_Daily_change, data = .))
  
  #Extract components
  
  RegressionResults <- mutate(RegressionResults, EquityBeta = model[[1]][2])
  
  ####Step 6 Calculate asset betas####
  #Using averages across the entire period
  
  #Bring in the adjusted net debt figure 
  
  CombinedData <- left_join(CombinedData, AltGearing, by = c("Code", "date"))
  
  CombinedData <- mutate(CombinedData, GearingDVAdj = adjNet_Debt/(CUR_MKT_CAP + adjNet_Debt) )
  
  SummaryValuesAll <- CombinedData %>% group_by(Code) %>%
    summarise(AverageGearingDE = mean(GearingDE, na.rm = TRUE), AverageGearingDV = mean(GearingDV, na.rm = TRUE), 
              AverageEffectiveTaxRate = mean(EFF_TAX_RATE, na.rm = TRUE), AverageGearingDVAdj = mean(GearingDVAdj, na.rm = TRUE))
  
  #Combine Results
  
  RegressionResults <- left_join(RegressionResults, SummaryValuesAll, by = c("Code")) %>% ungroup()
  
  #Calcualte asset betas
  #Using Brealey-Myers
  
  RegressionResults <- mutate(RegressionResults, Assetbeta = EquityBeta*(1-AverageGearingDV)) 
  RegressionResults <- mutate(RegressionResults, AdjAssetbeta = EquityBeta*(1-AverageGearingDVAdj))
  
  RegressionResults

}
