#' .. content for \description{} (no empty lines) ..
#'
#' .. content for \details{} ..
#'
#' @title
#' @param Inputs
get_data <- function(Inputs) {

  #Inputs is a list with 1.StartDate 2.EndDate 3. Firms
  
  #For the data extraction step start date needs to be 1 month prior, so 32 days additional
  
  StartDate <- Inputs[[1]]
  EndDate <- Inputs[[2]]
  Firms <- Inputs[[3]]
  Period <- Inputs[[4]]
  
  date <- seq.Date(from = StartDate, to = EndDate, by = 1)
  
  date <- expand.grid(date, Firms$Code)
  
  colnames(date) <- c("date", "Code")
  
  #Connect to Bloomberg
  
  blpConnect()
  
  RelIndex <- bdp(Firms$Code, "BETA_OVERRIDE_REL_INDEX")
  Firms$RelIndex <- RelIndex$BETA_OVERRIDE_REL_INDEX
  
  #Get firm data
  #Two stages as currency of mkt cap and net dbet dont always match
  
  Fields1 <- c("PX_LAST")
  Fields2 <- c("NET_DEBT", "CUR_MKT_CAP", "EFF_TAX_RATE")
  
  #Currency for MKTCAP and Net Debt set to USD
  
  FirmDataList <- bdh(securities = Firms$Code, fields = Fields1, start.date =  StartDate,
                      end.date = EndDate) #the CDR is 7D option means all days are extracted
  
  FirmData <- bind_rows(FirmDataList, .id = "Code")
  
  FirmData <- left_join(date, FirmData, by = c('date',"Code"))
  write.csv(FirmData, "test.csv")
  
  FirmDataList2 <- bdh(securities = Firms$Code, fields = Fields2, start.date =  StartDate,
                       end.date = EndDate, options = c("CDR" = "7D"), overrides = c("EQY_FUND_CRNCY" = "USD")) #the CDR is 7D option means all days are extracted
  
  FirmData2 <- bind_rows(FirmDataList2, .id = "Code")
  
  FirmData <- left_join(FirmData,FirmData2, by = c("Code","date"))
  
  #Get index data
  
  Fields <-  c("PX_LAST")
  
  IndexDataList <- bdh(securities = Firms$RelIndex, fields = Fields, start.date =  StartDate,
                       end.date = EndDate, options = c("CDR" = "7D"))
  
  names(IndexDataList)[names(IndexDataList) == ""] <- "Remove" #Error handling
  
  IndexData <- bind_rows(IndexDataList, .id = "RelIndex")
  
  colnames(IndexData) <- c("RelIndex", "date", "INDEX_PX_LAST")
  
  IndexData <- distinct(IndexData, date, RelIndex, .keep_all = TRUE)
  
  #Combine index and firm data
  
  FirmData <- left_join(FirmData, Firms, by = "Code")
  CombinedData <- left_join(FirmData, IndexData, by = c("RelIndex", "date"))
  
  #Intermediate output for QA
  
  write.csv(CombinedData, paste0(".//Outputs//InputData-",Period,"-",EndDate,".csv"), row.names = FALSE)
  
  CombinedData
  

}
