the_plan <-
  drake_plan(

    #This plan is for estimating betas using Bloomberg data
    #Note leverage is calculated D/(D+E)
    
    #1. Get inputs
    
    Inputs = get_inputs(),
    
    #2. Connect to Bloomberg and get the data
    #The object Data can be used for QA checks as it is raw Bloomberg data. 
    
    Data = get_data(Inputs),
    
    #Alternative gearing calculation
    
    AltGearing = calc_gearing(Inputs),
    
    ####Weekly Estimation procedures####
    
    #1. Clean the data to get it ready for weekly beta estimation
    
    CleanedData = clean_data_weekly(Data, Inputs),
    
    #2. Estimate weekly betas 
    
    BetaEstimates = estimate_beta_weekly(CleanedData, AltGearing),
    
    #3. Print weekly Results
    
    BetaOutputs_weekly(BetaEstimates, Inputs),
    
    ####Daily Estimation Procedures#####
    
    #1. Clean the data to get it ready for daily beta estimation
    
    CleanedDataDaily = clean_data_daily(Data, Inputs),
    
    #2. Estimate daily betas 
    
    BetaEstimatesDaily = estimate_beta_daily(CleanedDataDaily, AltGearing),
    
    #3. Print daily Results
    
    BetaOutputs_daily(BetaEstimatesDaily, Inputs),
    
    ####Four-weekly Estimation Procedures#####
    
    #1. Clean the data to get it ready for four-weekly beta estimation
    
    CleanedDataFourWeekly = clean_data_fourweekly(Data, Inputs),
    
    #2. Estimate four-weekly betas 
    
    BetaEstimatesFourweekly = estimate_beta_fourweekly(CleanedDataFourWeekly, AltGearing),
    
    #3. Print daily Results
    
    BetaOutputs_fourweekly(BetaEstimatesFourweekly, Inputs)

)
